// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1

package matt.messaging;

public enum EventType
{
    Message(0),
    Closed(1);

    private static EventType[] __values = new EventType[2];
    static
    {
        __values[0] = Message;
        __values[1] = Closed;
    }
    private int __value;

    public static final int _Message = 0;
    public static final int _Closed = 1;

    public static EventType
    convert(int val)
    {
        assert val < 2;
        return __values[val];
    }

    public static EventType
    convert(String val)
    {
        for(int __i = 0; __i < __values.length; ++__i)
        {
            if(__values[__i].toString().equals(val))
            {
                return __values[__i];
            }
        }
        assert false;
        return null;
    }

    public int
    value()
    {
        return __value;
    }

    private
    EventType(int val)
    {
        __value = val;
    }

    public void
    __write(IceInternal.BasicStream __os)
    {
        __os.writeByte((byte)__value);
    }

    public static EventType
    __read(IceInternal.BasicStream __is)
    {
        int __v = __is.readByte();
        if(__v < 0 || __v >= 2)
        {
            throw new Ice.MarshalException();
        }
        return EventType.convert(__v);
    }
}
