// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1

package matt.messaging;

public abstract class Mailbox extends Ice.ObjectImpl
                              implements _MailboxOperations,
                                         _MailboxOperationsNC
{
    public static final String[] __ids =
    {
        "::Ice::Object",
        "::matt::messaging::Mailbox"
    };

    public boolean
    ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean
    ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[]
    ice_ids()
    {
        return __ids;
    }

    public String[]
    ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String
    ice_id()
    {
        return __ids[1];
    }

    public String
    ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String
    ice_staticId()
    {
        return __ids[1];
    }

    public final boolean
    active()
    {
        return active(null);
    }

    public final void
    addListener(EventListenerPrx listener)
        throws matt.MattAlreadyListeningException,
               matt.MattListenException,
               matt.MattNotActiveException
    {
        addListener(listener, null);
    }

    public final boolean
    empty()
    {
        return empty(null);
    }

    public final String
    read()
        throws matt.MattNoMessageException,
               matt.MattNotActiveException
    {
        return read(null);
    }

    public final void
    removeListener()
        throws matt.MattListenException,
               matt.MattNotActiveException,
               matt.MattNotListeningException
    {
        removeListener(null);
    }

    public final void
    write(String message)
        throws matt.MattNotActiveException
    {
        write(message, null);
    }

    public static IceInternal.DispatchStatus
    ___empty(Mailbox __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __os = __inS.os();
        boolean __ret = __obj.empty(__current);
        __os.writeBool(__ret);
        return IceInternal.DispatchStatus.DispatchOK;
    }

    public static IceInternal.DispatchStatus
    ___active(Mailbox __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __os = __inS.os();
        boolean __ret = __obj.active(__current);
        __os.writeBool(__ret);
        return IceInternal.DispatchStatus.DispatchOK;
    }

    public static IceInternal.DispatchStatus
    ___read(Mailbox __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __os = __inS.os();
        try
        {
            String __ret = __obj.read(__current);
            __os.writeString(__ret);
            return IceInternal.DispatchStatus.DispatchOK;
        }
        catch(matt.MattNoMessageException ex)
        {
            __os.writeUserException(ex);
            return IceInternal.DispatchStatus.DispatchUserException;
        }
        catch(matt.MattNotActiveException ex)
        {
            __os.writeUserException(ex);
            return IceInternal.DispatchStatus.DispatchUserException;
        }
    }

    public static IceInternal.DispatchStatus
    ___write(Mailbox __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.is();
        IceInternal.BasicStream __os = __inS.os();
        String message;
        message = __is.readString();
        try
        {
            __obj.write(message, __current);
            return IceInternal.DispatchStatus.DispatchOK;
        }
        catch(matt.MattNotActiveException ex)
        {
            __os.writeUserException(ex);
            return IceInternal.DispatchStatus.DispatchUserException;
        }
    }

    public static IceInternal.DispatchStatus
    ___addListener(Mailbox __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.is();
        IceInternal.BasicStream __os = __inS.os();
        EventListenerPrx listener;
        listener = EventListenerPrxHelper.__read(__is);
        try
        {
            __obj.addListener(listener, __current);
            return IceInternal.DispatchStatus.DispatchOK;
        }
        catch(matt.MattAlreadyListeningException ex)
        {
            __os.writeUserException(ex);
            return IceInternal.DispatchStatus.DispatchUserException;
        }
        catch(matt.MattListenException ex)
        {
            __os.writeUserException(ex);
            return IceInternal.DispatchStatus.DispatchUserException;
        }
        catch(matt.MattNotActiveException ex)
        {
            __os.writeUserException(ex);
            return IceInternal.DispatchStatus.DispatchUserException;
        }
    }

    public static IceInternal.DispatchStatus
    ___removeListener(Mailbox __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __os = __inS.os();
        try
        {
            __obj.removeListener(__current);
            return IceInternal.DispatchStatus.DispatchOK;
        }
        catch(matt.MattNotListeningException ex)
        {
            __os.writeUserException(ex);
            return IceInternal.DispatchStatus.DispatchUserException;
        }
        catch(matt.MattListenException ex)
        {
            __os.writeUserException(ex);
            return IceInternal.DispatchStatus.DispatchUserException;
        }
        catch(matt.MattNotActiveException ex)
        {
            __os.writeUserException(ex);
            return IceInternal.DispatchStatus.DispatchUserException;
        }
    }

    private final static String[] __all =
    {
        "active",
        "addListener",
        "empty",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "read",
        "removeListener",
        "write"
    };

    public IceInternal.DispatchStatus
    __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            return IceInternal.DispatchStatus.DispatchOperationNotExist;
        }

        switch(pos)
        {
            case 0:
            {
                return ___active(this, in, __current);
            }
            case 1:
            {
                return ___addListener(this, in, __current);
            }
            case 2:
            {
                return ___empty(this, in, __current);
            }
            case 3:
            {
                return ___ice_id(this, in, __current);
            }
            case 4:
            {
                return ___ice_ids(this, in, __current);
            }
            case 5:
            {
                return ___ice_isA(this, in, __current);
            }
            case 6:
            {
                return ___ice_ping(this, in, __current);
            }
            case 7:
            {
                return ___read(this, in, __current);
            }
            case 8:
            {
                return ___removeListener(this, in, __current);
            }
            case 9:
            {
                return ___write(this, in, __current);
            }
        }

        assert(false);
        return IceInternal.DispatchStatus.DispatchOperationNotExist;
    }

    public void
    __write(IceInternal.BasicStream __os)
    {
        __os.writeTypeId(ice_staticId());
        __os.startWriteSlice();
        __os.endWriteSlice();
        super.__write(__os);
    }

    public void
    __read(IceInternal.BasicStream __is, boolean __rid)
    {
        if(__rid)
        {
            __is.readTypeId();
        }
        __is.startReadSlice();
        __is.endReadSlice();
        super.__read(__is, true);
    }

    public void
    __write(Ice.OutputStream __outS)
    {
        Ice.MarshalException ex = new Ice.MarshalException();
        ex.reason = "type matt::messaging::Mailbox was not generated with stream support";
        throw ex;
    }

    public void
    __read(Ice.InputStream __inS, boolean __rid)
    {
        Ice.MarshalException ex = new Ice.MarshalException();
        ex.reason = "type matt::messaging::Mailbox was not generated with stream support";
        throw ex;
    }
}
