// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1

package matt.messaging;

public final class MailboxPrxHelper extends Ice.ObjectPrxHelperBase implements MailboxPrx
{
    public boolean
    active()
    {
        return active(null, false);
    }

    public boolean
    active(java.util.Map<String, String> __ctx)
    {
        return active(__ctx, true);
    }

    @SuppressWarnings("unchecked")
    private boolean
    active(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("active");
                __delBase = __getDelegate();
                _MailboxDel __del = (_MailboxDel)__delBase;
                return __del.active(__ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    addListener(EventListenerPrx listener)
        throws matt.MattAlreadyListeningException,
               matt.MattListenException,
               matt.MattNotActiveException
    {
        addListener(listener, null, false);
    }

    public void
    addListener(EventListenerPrx listener, java.util.Map<String, String> __ctx)
        throws matt.MattAlreadyListeningException,
               matt.MattListenException,
               matt.MattNotActiveException
    {
        addListener(listener, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    addListener(EventListenerPrx listener, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws matt.MattAlreadyListeningException,
               matt.MattListenException,
               matt.MattNotActiveException
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("addListener");
                __delBase = __getDelegate();
                _MailboxDel __del = (_MailboxDel)__delBase;
                __del.addListener(listener, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public boolean
    empty()
    {
        return empty(null, false);
    }

    public boolean
    empty(java.util.Map<String, String> __ctx)
    {
        return empty(__ctx, true);
    }

    @SuppressWarnings("unchecked")
    private boolean
    empty(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("empty");
                __delBase = __getDelegate();
                _MailboxDel __del = (_MailboxDel)__delBase;
                return __del.empty(__ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public String
    read()
        throws matt.MattNoMessageException,
               matt.MattNotActiveException
    {
        return read(null, false);
    }

    public String
    read(java.util.Map<String, String> __ctx)
        throws matt.MattNoMessageException,
               matt.MattNotActiveException
    {
        return read(__ctx, true);
    }

    @SuppressWarnings("unchecked")
    private String
    read(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws matt.MattNoMessageException,
               matt.MattNotActiveException
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("read");
                __delBase = __getDelegate();
                _MailboxDel __del = (_MailboxDel)__delBase;
                return __del.read(__ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    removeListener()
        throws matt.MattListenException,
               matt.MattNotActiveException,
               matt.MattNotListeningException
    {
        removeListener(null, false);
    }

    public void
    removeListener(java.util.Map<String, String> __ctx)
        throws matt.MattListenException,
               matt.MattNotActiveException,
               matt.MattNotListeningException
    {
        removeListener(__ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    removeListener(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws matt.MattListenException,
               matt.MattNotActiveException,
               matt.MattNotListeningException
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("removeListener");
                __delBase = __getDelegate();
                _MailboxDel __del = (_MailboxDel)__delBase;
                __del.removeListener(__ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public void
    write(String message)
        throws matt.MattNotActiveException
    {
        write(message, null, false);
    }

    public void
    write(String message, java.util.Map<String, String> __ctx)
        throws matt.MattNotActiveException
    {
        write(message, __ctx, true);
    }

    @SuppressWarnings("unchecked")
    private void
    write(String message, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws matt.MattNotActiveException
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("write");
                __delBase = __getDelegate();
                _MailboxDel __del = (_MailboxDel)__delBase;
                __del.write(message, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, __cnt);
            }
        }
    }

    public static MailboxPrx
    checkedCast(Ice.ObjectPrx __obj)
    {
        MailboxPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (MailboxPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                if(__obj.ice_isA("::matt::messaging::Mailbox"))
                {
                    MailboxPrxHelper __h = new MailboxPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static MailboxPrx
    checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        MailboxPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (MailboxPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                if(__obj.ice_isA("::matt::messaging::Mailbox", __ctx))
                {
                    MailboxPrxHelper __h = new MailboxPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static MailboxPrx
    checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        MailboxPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA("::matt::messaging::Mailbox"))
                {
                    MailboxPrxHelper __h = new MailboxPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static MailboxPrx
    checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        MailboxPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA("::matt::messaging::Mailbox", __ctx))
                {
                    MailboxPrxHelper __h = new MailboxPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static MailboxPrx
    uncheckedCast(Ice.ObjectPrx __obj)
    {
        MailboxPrx __d = null;
        if(__obj != null)
        {
            MailboxPrxHelper __h = new MailboxPrxHelper();
            __h.__copyFrom(__obj);
            __d = __h;
        }
        return __d;
    }

    public static MailboxPrx
    uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        MailboxPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            MailboxPrxHelper __h = new MailboxPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    protected Ice._ObjectDelM
    __createDelegateM()
    {
        return new _MailboxDelM();
    }

    protected Ice._ObjectDelD
    __createDelegateD()
    {
        return new _MailboxDelD();
    }

    public static void
    __write(IceInternal.BasicStream __os, MailboxPrx v)
    {
        __os.writeProxy(v);
    }

    public static MailboxPrx
    __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            MailboxPrxHelper result = new MailboxPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }
}
